<?php
  // $Id: movies_db_functions.inc,v 1.2.2.1 2007/09/17 14:45:56 ianbezanson Exp $
  
  /********************************************************************
   * movies_db_functions.inc
   *
   * Helper functions for movies database
   *
   ********************************************************************/

  /**
   * movies_add()
   *
   * Add a new movie to the database.
   */
  function movies_add($movie_name, $movie_genre, $movie_year, $movie_format, $imdb_link)
  {
    if(!is_numeric($movie_year))
    {
      watchdog('Movies', 'Cannot Add Movie! Year supplied (' . $movie_year . ') was not an integer!');
      return false;
    }

    //insert the movies record
    $sql = 'INSERT INTO {movies}
            (
              movie_name,
              movie_genre,
              movie_year,
              movie_format,
              imdb_link,
              date_added
            )
            VALUES
            (
              "' . $movie_name   . '",
              "' . $movie_genre  . '",
               ' . $movie_year   . ',
              "' . $movie_format . '",
              "' . $imdb_link    . '",
               ' . mktime() . '
            );';

    watchdog('Movies', 'Received Add Request:\n' . $sql);
    if (db_query($sql) == false)
    {
      watchdog('Movies', 'SQL Failed when adding movie!');
      return false;
    }
    watchdog('Movies', 'SQL Succeeded when adding movie!');
    return true;
  }
  
  /**
   * movies_update()
   *
   * Check to see that movie exists, and then update fields for
   * an existing movie.
   */
  function movies_update($movie_id, $movie_name, $movie_genre, $movie_year, $movie_format, $imdb_link)
  {
    if(!is_numeric($movie_year))
    {
      watchdog('Movies', 'Cannot Add Movie! Year supplied (' . $movie_year . ') was not an integer!');
      return false;
    }

    $num_movies = db_affected_rows(movies_find($movie_id));

    if($num_movies == 0)
    {
      watchdog('Movies', 'Cannot Update Movie! Movie ID: ' . $movie_id . ' does not exist!');
      return true;
    }

    //insert the movies record
    $sql = 'UPDATE {movies} SET
                movie_name="'   . $movie_name . '", 
                movie_genre="'  . $movie_genre . '", 
                movie_year='    . $movie_year . ', 
                movie_format="' . $movie_format . '", 
                imdb_link="'    . $imdb_link . '" 
            WHERE movie_id='    . $movie_id . ';';

    watchdog('movies', 'Received Update Request:\n' . $sql);
    if (db_query($sql) == false)
    {
      watchdog('movies', 'SQL Failed when updating movie!');
      return false;
    }
    watchdog('movies', 'SQL Succeeded when updating movie!');
    return true;
  }

  /**
   * movies_remove()
   *
   * Check to see that movie exists, and then delete it.
   */
  function movies_remove($movie_id)
  {
    if(!is_numeric($movie_id))
    {
      watchdog('Movies', 'Cannot Delete Movie! ID supplied (' . $movie_id . 'was not an integer!');
      return false;
    }

    $num_movies = db_affected_rows(movies_find($movie_id));

    if($num_movies == 0)
    {
      watchdog('Movies', 'Cannot Delete Movie! Movie ID: ' . $movie_id . ' does not exist!');
      return true;
    }

    //delete the movies record
    $sql = 'DELETE FROM {movies} where movie_id = ' . $movie_id . ';';
    if(db_query($sql) == false)
    {
      watchdog('Movies', 'Cannot Delete Movie! Query Failed!');
      return false;
    }
    return true;
  }
  
  /**
   * movies_list()
   *
   * Returns a list of all movies in the database.
   */
  function movies_list($addtlSQL)
  {
    $sql = '
      SELECT
          *
      FROM
        {movies}
    ';

    $movie_count = '
      SELECT
        count(movie_id) as this_count
      FROM
      (
        ' . $sql . '
      ) count_table
    ';

    $movies = pager_query
    (
      db_rewrite_sql
      (
          $sql
        . $addtlSQL,
        'movies',
        'movie_id'
      ),
      variable_get('movies_paginate', '50'),
      0,
      $movie_count
    );

    return $movies;
  }
  
  /**
   * movies_find()
   *
   * Finds a specific movie (by movie_id) in the database
   */
  function movies_find($movie_id)
  {
    $movies = db_query
    ('
      SELECT
        *
      FROM
        {movies}
      WHERE
        movie_id= ' . $movie_id . '
    ');
    return $movies;
  }

  /**
   * wishlist_movies_list()
   *
   * Returns a list of all movies in the database.
   */
  function wishlist_movies_list($addtlSQL)
  {
    $sql = '
      SELECT
        *
      FROM
        {movies_wishlist}
      WHERE
        added_to_movies = 0
    ';
    $movie_wishlist_count = '
      SELECT
        count(movie_id) as this_count
      FROM
      (
        ' . $sql . '
      ) count_table
    ';

    $movie_wishlist = pager_query
    (
      db_rewrite_sql
      (
          $sql
        . $addtlSQL,
        'movies_wishlist',
        'movie_id'
      ),
      variable_get('movies_paginate', '50'),
      0,
      $movie_wishlist_count
    );

    return $movie_wishlist;
  }

  /**
   * wishlist_movies_find()
   *
   * Finds a specific movie (by movie_id) in the database
   */
  function wishlist_movies_find($movie_id)
  {
    $movies = db_query("SELECT * FROM {movies_wishlist} where movie_id=$movie_id");
    return $movies;
  }
  
  /**
   * wishlist_movies_add()
   *
   * Add a new movie to the database.
   */
  function wishlist_movies_add($movie_name, $movie_genre, $movie_year, $movie_format, $imdb_link)
  {
    if(!is_numeric($movie_year))
    {
      watchdog('Movies', 'Cannot Add Wishlist Movie! Year supplied (' . $movie_year . ') was not an integer!');
      return false;
    }

    //insert the movies record
    $sql = 'INSERT INTO {movies_wishlist}
            (
              movie_name,
              movie_genre,
              movie_year,
              movie_format,
              imdb_link,
              date_added,
              added_to_movies
            )
            VALUES
            (
              "' . $movie_name   . '",
              "' . $movie_genre  . '",
               ' . $movie_year   . ',
              "' . $movie_format . '",
              "' . $imdb_link    . '",
               ' . mktime() . ',
               0
            );';

    watchdog('Movies', 'Received Add Request:\n' . $sql);
    if (db_query($sql) == false)
    {
      watchdog('Movies', 'SQL Failed when adding wishlist movie!');
      return false;
    }
    watchdog('Movies', 'SQL Succeeded when adding wishlist movie!');
    return true;
  }
  
  /**
   * wishlist_movies_update()
   *
   * Check to see that movie exists, and then update fields for
   * an existing movie.
   */
  function wishlist_movies_update($movie_id, $movie_name, $movie_genre, $movie_year, $movie_format, $imdb_link)
  {
    if(!is_numeric($movie_year))
    {
      watchdog('Movies', 'Cannot Add Wishlist Movie! Year supplied (' . $movie_year . ') was not an integer!');
      return false;
    }

    $num_movies = db_affected_rows(wishlist_movies_find($movie_id));

    if($num_movies == 0)
    {
      watchdog('Movies', 'Cannot Update Wishlist Movie! Movie ID: ' . $movie_id . ' does not exist!');
      return true;
    }

    //insert the movies record
    $sql = 'UPDATE {movies_wishlist} SET
                movie_name="'   . $movie_name . '", 
                movie_genre="'  . $movie_genre . '", 
                movie_year='    . $movie_year . ', 
                movie_format="' . $movie_format . '", 
                imdb_link="'    . $imdb_link . '" 
            WHERE movie_id='    . $movie_id . ';';

    watchdog('movies', 'Received Update Request:\n' . $sql);
    if (db_query($sql) == false)
    {
      watchdog('movies', 'SQL Failed when updating wishlist movie!');
      return false;
    }
    watchdog('movies', 'SQL Succeeded when updating wishlist movie!');
    return true;
  }

  /**
   * wishlist_movies_remove()
   *
   * Check to see that movie exists, and then delete it.
   */
  function wishlist_movies_remove($movie_id)
  {
    if(!is_numeric($movie_id))
    {
      watchdog('Movies', 'Cannot Delete Wishlist Movie! ID supplied (' . $movie_id . 'was not an integer!');
      return false;
    }

    $num_movies = db_affected_rows(wishlist_movies_find($movie_id));

    if($num_movies == 0)
    {
      watchdog('Movies', 'Cannot Delete Wishlist Movie! Movie ID: ' . $movie_id . ' does not exist!');
      return true;
    }

    //delete the movies record
    $sql = 'DELETE FROM {movies_wishlist} where movie_id = ' . $movie_id . ';';
    if(db_query($sql) == false)
    {
      watchdog('Movies', 'Cannot Delete Wishlist Movie! Query Failed!');
      return false;
    }
    return true;
  }
  
  /**
   * wishlist_to_movie()
   *
   * When a wishlist item is checked off, we'll add it to the movie list
   * and update it's status in the wishlist to show it's been added.
   */
  function wishlist_to_movie($movie_id)
  {
    if(!is_numeric($movie_id))
    {
      return 0;
    }

    $sql = '
      select
        movie_name, movie_genre, movie_year, movie_format, imdb_link
      from {movies_wishlist}
      where movie_id = ' . $movie_id . 
      ';';
    $movielist = db_fetch_object(db_query($sql));

    //Start a new transaction
    if (db_query('START TRANSACTION') == false)
    {
      return false;
    }

    $sql = 'INSERT INTO {movies}
            (
              movie_name,
              movie_genre,
              movie_year,
              movie_format,
              imdb_link,
              date_added
            )
            VALUES
            (
              "' . $movielist->movie_name   . '",
              "' . $movielist->movie_genre  . '",
               ' . $movielist->movie_year   . ',
              "' . $movielist->movie_format . '",
              "' . $movielist->imdb_link    . '",
               ' . mktime() . '
            );';
    watchdog('movies', 'Attempting To Add Movie From Wishlist: ' . $sql);
    if (db_query($sql) == false)
    {
      db_query('ROLLBACK');
      watchdog('movies', 'Failed SQL Query... Rolling Back.');
      return false;
    }
    $sql = 'UPDATE {movies_wishlist} set added_to_movies=1 where movie_id = ' . $movie_id;
    watchdog('movies', 'Attempting To Change Status in Wishlist Table to Added: ' . $sql);
    if (db_query($sql) == false)
    {
      db_query('ROLLBACK');
      watchdog('movies', 'Failed SQL Query... Rolling Back.');
      return false;
    }
    db_query('COMMIT');
    return true;
  }
  
  /**
   * get_conflicts()
   *
   * Find any conflicts between the movie and movie wishlist tables (where
   * a movie is active in both).
   */
  function get_conflicts($addtlSQL)
  {
    $sql = '
      SELECT 
        movies.movie_name,
        movies.movie_genre,
        movies.movie_year,
        movies.movie_format,
        movies.imdb_link,
        movies.date_added,
        movies_wishlist.movie_id
      FROM
        movies 
      JOIN
        movies_wishlist on movies.movie_name=movies_wishlist.movie_name
        and movies.movie_year=movies_wishlist.movie_year
      WHERE
        movies_wishlist.added_to_movies=0
    ';

    $conflict_count = '
      SELECT
        count(movie_id) as this_count
      FROM
      (
        ' . $sql . '
      ) count_table
    ';

    $conflicts = pager_query
    (
      db_rewrite_sql
      (
          $sql
        . $addtlSQL,
        'movies',
        'movie_id'
      ),
      variable_get('movies_paginate', '50'),
      0,
      $movie_wishlist_count
    );

    return $conflicts;
  }

  /**
   * conflict_resolve_db()
   *
   * If a conflict is chosen to be fixed, we'll simply update it's status 
   * in the wishlist table to be added.
   */
  function conflict_resolve_db($movie_id)
  {
    if(!is_numeric($movie_id))
    {
      return 0;
    }
    $sql = 'UPDATE {movies_wishlist} SET
                added_to_movies=1
            WHERE movie_id='    . $movie_id . ';';

    watchdog('movies', 'Received Conflict Resolution Request:\n' . $sql);
    if (db_query($sql) == false)
    {
      watchdog('movies', 'SQL Failed when resolving conflict with wishlist movie!');
      return false;
    }
    return true;
  }
